#ifndef _PATCHWISE_CORE_ENGINE_2_APPLY_H
#define _PATCHWISE_CORE_ENGINE_2_APPLY_H

#ifdef __cplusplus
extern "C"
{
#endif

#if defined(PWCE2A_EXPORTS)
#	define PWCE2AFUNC	__declspec (dllexport)
#	define PWCE2ADATA	__declspec (dllexport)
#elif defined(PWCE2A_IMPORTS)
#	define PWCE2AFUNC	__declspec (dllimport)
#	define PWCE2ADATA	__declspec (dllimport)
#else
#	define PWCE2AFUNC
#	define PWCE2ADATA
#endif

#define countof(x)	(sizeof(x)/sizeof(x[0]))

#ifndef PWCE2A_EXPORTS
	#ifdef PWCE2A_IMPORTS
		#ifdef _DEBUG
			#pragma comment(lib, "pwce2axd.lib")
		#else
			#pragma comment(lib, "pwce2ax.lib")
		#endif
	#else
	#endif
#endif // PWCE2A_EXPORTS

#define PAERR_SUCCESS			0
#define PAERR_MALLOC_FAILED		-1
#define PAERR_NO_THREAD			-2
#define PAERR_OLD_FILE_OPEN		-3
#define PAERR_OUT_FILE_OPEN		-4
#define PAERR_PATCH_FILE_OPEN	-5
#define PAERR_OLD_FILE_READ		-6
#define PAERR_OUT_FILE_WRITE	-7
#define PAERR_PATCH_FILE_READ	-8
#define PAERR_OLD_FILE_SUM		-9
#define PAERR_OUT_FILE_SUM		-10

extern PWCE2AFUNC void WINAPI PwaEnableThreadMode(BOOL bEnable);
extern PWCE2AFUNC BOOL WINAPI PwaSetThreadPriority(int nPriority);
extern PWCE2AFUNC int WINAPI PwaGetRunningStatus();
extern PWCE2AFUNC int WINAPI PwaApplyPatch(LPCSTR pszPatchFilePath,
	LPCSTR pszOriginalFilePath, LPCSTR pszOutputFilePath);

#ifdef __cplusplus
}
#endif

#endif // _PATCHWISE_CORE_ENGINE_2_APPLY_H
