#ifndef _PATCHWISE_CORE_ENGINE_2_GENERATE_H
#define _PATCHWISE_CORE_ENGINE_2_GENERATE_H

#ifdef __cplusplus
extern "C" 
{
#endif

#if defined(PWCE2G_EXPORTS)
#	define PWCE2GFUNC	__declspec (dllexport)
#	define PWCE2GDATA	__declspec (dllexport)
#elif defined(PWCE2G_IMPORTS)
#	define PWCE2GFUNC	__declspec (dllimport)
#	define PWCE2GDATA	__declspec (dllimport)
#else
#	define PWCE2GFUNC
#	define PWCE2GDATA
#endif

#ifndef PWCE2G_EXPORTS
	#ifdef PWCE2G_IMPORTS
		#ifdef _DEBUG
			#pragma comment(lib, "pwce2gxd.lib")
		#else
			#pragma comment(lib, "pwce2gx.lib")
		#endif
	#else
	#endif
#endif // PWCE2G_EXPORTS

#define PGERR_SUCCESS			0
#define PGERR_MALLOC_FAILED		-1
#define PGERR_NO_THREAD			-2
#define PGERR_OLD_FILE_OPEN		-3
#define PGERR_NEW_FILE_OPEN		-4
#define PGERR_PATCH_FILE_OPEN	-5
#define PGERR_OLD_FILE_READ		-6
#define PGERR_NEW_FILE_READ		-7
#define PGERR_PATCH_FILE_WRITE	-8

extern PWCE2GFUNC void WINAPI PwgSetMaxMemoryUsage(int nMegabytes);
extern PWCE2GFUNC void WINAPI PwgEnableThreadMode(BOOL bEnable);
extern PWCE2GFUNC void WINAPI PwgEnableChecksum(BOOL bEnable);
extern PWCE2GFUNC void WINAPI PwgSetSpeedLevel(int nSpeed);
extern PWCE2GFUNC BOOL WINAPI PwgSetThreadPriority(int nPriority);
extern PWCE2GFUNC int WINAPI PwgGetRunningStatus();
extern PWCE2GFUNC int WINAPI PwgGeneratePatch(LPCSTR pszOriginalFilePath, 
	LPCSTR pszOutputFilePath, LPCSTR pszPatchFilePath);


#ifdef __cplusplus
}
#endif

#endif // _PATCHWISE_CORE_ENGINE_2_GENERATE_H
